unit list;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  stdctrls, DdeMan;

type
  TTestObject = class(TButton)
  public
    destructor Destroy; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
  end;

  TForm1 = class(TForm)
    ButtonPoista: TButton;
    ButtonAseta: TButton;
    DdeClientItem1: TDdeClientItem;
    DdeClientConv1: TDdeClientConv;
    Label1: TLabel;
    ITEM1: TDdeServerItem;
    ButtonLisaa: TButton;
    Label2: TLabel;
    ButtonOta: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ButtonPoistaClick(Sender: TObject);
    procedure ButtonAsetaClick(Sender: TObject);
    procedure DdeClientItem1Change(Sender: TObject);
    procedure ButtonLisaaClick(Sender: TObject);
    procedure ButtonOtaClick(Sender: TObject);
  private
    napit : TList;
  public
  end;

var
  Form1: TForm1;

implementation

destructor TTestObject.Destroy;
begin
  inherited;
end;

procedure TTestObject.KeyDown(var Key: Word; Shift: TShiftState);
begin
  Caption := IntToHex(Key,4);
  Key := 0;
end;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var y,dy:integer; c : TTestObject;
begin
  napit := TList.Create;
  dy := 30;
  y := 10;

  while ( y+dy < ClientHeight ) do begin
    c := TTestObject.Create(self);
    c.Parent := self;
    c.Top := y;
    c.Left := 20;
    c.Width := 100;
    c.Caption := IntToStr(y);
    c.Height := dy;
    y := y + dy;
    napit.Add(c);
  end;
end;

procedure TForm1.ButtonPoistaClick(Sender: TObject);
begin
  if ( Napit <> NIL ) then begin Napit.Free; Napit := nil; end;
  Sender.Free; 
end;

procedure TForm1.ButtonAsetaClick(Sender: TObject);
var i:integer; c : TTestObject;
begin
  if napit = nil then exit;
  for i:=0 to napit.count-1 do begin
    c := napit[i];
    c.Caption := IntToStr(i);
  end;

end;

procedure TForm1.DdeClientItem1Change(Sender: TObject);
begin
  Label1.Caption := DdeClientItem1.Text;
end;

procedure TForm1.ButtonLisaaClick(Sender: TObject);
begin
  Label2.Caption := IntToStr(StrToInt(Label2.Caption)+1);
  ITEM1.CopyToClipboard;
  ITEM1.Text := Label2.Caption;

end;

procedure TForm1.ButtonOtaClick(Sender: TObject);
begin
  DdeClientConv1.PasteLink;
end;

end.
